#
# Conditional build:
%bcond_without	doc	# Sphinx documentation
%bcond_without	tests	# test action

%define		module	werkzeug
Summary:	The Swiss Army knife of Python web development
Summary(pl.UTF-8):	Scyzoryk szwajcarski programisty aplikacji WWW
Name:		python3-%{module}
Version:	3.1.3
Release:	1
License:	BSD
Group:		Development/Languages/Python
# pypi release misses docs/_themes directory
##Source0Download: https://pypi.org/simple/Werkzeug
#Source0:	https://files.pythonhosted.org/packages/source/W/Werkzeug/Werkzeug-%{version}.tar.gz
#Source0Download: https://github.com/pallets/werkzeug/releases
Source0:	https://github.com/pallets/werkzeug/archive/%{version}/werkzeug-%{version}.tar.gz
# Source0-md5:	1ef8005efcc0602d4a74359ac521b9d2
URL:		https://werkzeug.palletsprojects.com/
BuildRequires:	python3-devel >= 1:3.7
BuildRequires:	python3-modules >= 1:3.7
BuildRequires:	python3-build
BuildRequires:	python3-installer
%if %{with tests}
BuildRequires:	python3-cryptography
BuildRequires:	python3-ephemeral_port_reserve
BuildRequires:	python3-greenlet
BuildRequires:	python3-markupsafe >= 2.1.1
BuildRequires:	python3-pyOpenSSL
BuildRequires:	python3-pytest
BuildRequires:	python3-pytest-timeout
BuildRequires:	python3-pytest-xprocess
BuildRequires:	python3-requests
BuildRequires:	python3-watchdog
%endif
BuildRequires:	rpm-pythonprov
BuildRequires:	rpmbuild(macros) >= 1.714
%if %{with doc}
BuildRequires:	python3-pallets-sphinx-themes
BuildRequires:	python3-sphinx_issues
BuildRequires:	python3-sphinxcontrib-log-cabinet
BuildRequires:	sphinx-pdg-3
%endif
Requires:	python3-modules >= 1:3.7
BuildArch:	noarch
BuildRoot:	%{tmpdir}/%{name}-%{version}-root-%(id -u -n)

%description
Werkzeug started as simple collection of various utilities for WSGI
applications and has become one of the most advanced WSGI utility
modules. It includes a powerful debugger, full featured request and
response objects, HTTP utilities to handle entity tags, cache control
headers, HTTP dates, cookie handling, file uploads, a powerful URL
routing system and a bunch of community contributed addon modules.

%description -l pl.UTF-8
Werkzeug początkowo był prostym zbiorem różnych narzędzi dla aplikacji
WSGI, a stał się jednym z najbardziej zaawansowanych modułów
narzędziowych WSGI. Zawiera potężny debugger, obiekty żądania i
odpowiedzi z pełną funkcjonalnością, narzędzia HTTP do obsługi
znaczników encji, nagłówki sterujące buforowaniem, daty HTTP, obsługę
ciasteczek, przesyłanie plików, potężny system trasowania URL oraz
wiele dodatkowych modułów udostępnionych przez społeczność.

%package apidocs
Summary:	Documentation for Python Werkzeug package
Summary(pl.UTF-8):	Dokumentacja do pakietu Pythona Werkzeug
Group:		Documentation

%description apidocs
Documentation for Python Werkzeug package.

%description apidocs -l pl.UTF-8
Dokumentacja do pakietu Pythona Werkzeug.

%prep
%setup -q -n werkzeug-%{version}

%build
%py3_build_pyproject

%if %{with tests}
LC_ALL=C.UTF-8 \
PYTEST_DISABLE_PLUGIN_AUTOLOAD=1 \
PYTEST_PLUGINS=pytest_timeout,xprocess.pytest_xprocess \
PYTHONPATH=$(pwd)/src \
%{__python3} -m pytest tests -m 'not dev_server' -k 'not test_exclude_patterns'
# dev_server tests fail with connection refused(?)
# test_exclude_patterns seems to fail with sys.prefix == sys.base_prefix (?)
%endif

%if %{with doc}
%{__python3} -m zipfile -e build-3/*.whl build-3-doc
PYTHONPATH=$(pwd)/build-3-doc \
%{__make} -C docs html \
	SPHINXBUILD=sphinx-build-3
%endif

%install
rm -rf $RPM_BUILD_ROOT

%py3_install_pyproject

install -d $RPM_BUILD_ROOT%{_examplesdir}/python3-%{module}-%{version}
cp -a examples/* $RPM_BUILD_ROOT%{_examplesdir}/python3-%{module}-%{version}
find $RPM_BUILD_ROOT%{_examplesdir}/python3-%{module}-%{version} -name '*.py' \
	| xargs sed -i '1s|^#!.*python\b|#!%{__python3}|'

%clean
rm -rf $RPM_BUILD_ROOT

%files
%defattr(644,root,root,755)
%doc CHANGES.rst LICENSE.txt README.md
%{py3_sitescriptdir}/werkzeug
%{py3_sitescriptdir}/werkzeug-%{version}.dist-info
%{_examplesdir}/python3-%{module}-%{version}

%if %{with doc}
%files apidocs
%defattr(644,root,root,755)
%doc docs/_build/html/{_images,_static,deployment,middleware,*.html,*.js}
%endif
%changelog
* Wed Apr 30 2025 PLD Linux Team <feedback@pld-linux.org>
- For complete changelog see: http://git.pld-linux.org/?p=packages/python3-werkzeug.git;a=log;h=master

* Mon Apr 07 2025 Jan Rękorajski <baggins@pld-linux.org> d95ed9a
- up to 3.1.3

* Tue Mar 11 2025 Jan Rękorajski <baggins@pld-linux.org> b4c4d63
- doc/test rebuild for python 3.13

* Mon Mar 10 2025 Jan Rękorajski <baggins@pld-linux.org> 73d5d7e
- python 3.13 rebuild

* Thu Oct 12 2023 Jakub Bogusz <qboosh@pld-linux.org> 42a506a
- updated to 2.2.3

* Wed Dec 21 2022 Arkadiusz Miśkiewicz <arekm@maven.pl> 8cac1ad
- Up to 2.2.2

* Wed Mar 30 2022 Jan Rękorajski <baggins@pld-linux.org> 89f0c7a
- rebuild with tests and docs

* Sat Mar 26 2022 Jan Rękorajski <baggins@pld-linux.org> c96cf9f
- rebuild with python 3.10

* Fri Oct 22 2021 Jan Rękorajski <baggins@pld-linux.org> b8181ae
- updated doc BRs

* Fri Oct 22 2021 Jan Rękorajski <baggins@pld-linux.org> 4a8c22d
- Release 3 (by relup.sh)

* Wed Oct 13 2021 Arkadiusz Miśkiewicz <arekm@maven.pl> b1fcb24
- Rel 3; fix name

* Wed Oct 13 2021 Arkadiusz Miśkiewicz <arekm@maven.pl> 3e1962a
- Up to 2.0.2 (supports python 3.6+)

* Sat Feb 27 2021 Jan Rękorajski <baggins@pld-linux.org> 179cd11
- release 2 (by relup.sh)

* Tue Jan 26 2021 Jakub Bogusz <qboosh@pld-linux.org> faf6ada
- updated to 1.0.1

* Fri Jan 17 2020 Arkadiusz Miśkiewicz <arekm@maven.pl> 3188be7
- up to 0.16.0

* Mon Oct 28 2019 Jan Rękorajski <baggins@pld-linux.org> 5ac4f4a
- rebuild with python 3.8
- release 2 (by relup.sh)

* Sun Nov 11 2018 Jan Rękorajski <baggins@pld-linux.org> 995eef0
- up to 0.14.1

* Sun Jul 01 2018 Arkadiusz Miśkiewicz <arekm@maven.pl> d2b84ab
- release 2 (by relup.sh)

* Sun Apr 23 2017 Jakub Bogusz <qboosh@pld-linux.org> 7800109
- updated to 0.12.1
- removed obsolete py3 patch

* Mon Mar 06 2017 Jakub Bogusz <qboosh@pld-linux.org> 7c90b45
- updated to 0.11.15
- added py3 patch (fix one python3 incompatibility in contrib module used to build docs)
- pl, build -apidocs

* Thu Dec 29 2016 Arkadiusz Miśkiewicz <arekm@maven.pl> ae4655c
- python 3.6
- release 3 (by relup.sh)

